#!/usr/bin/env node
var WebSocketServer = require('websocket').server;
var http = require('http');

// SeA - 09/2021
// Classe WebSocket multi-clients

class ws_comm {
	constructor (port, idmsg) {
		this.port = port;
		this.idmsg = idmsg;
		this.http;
		this.ws;
		this.listeConnexions = []; // Liste des clients
	}
	
	connexion() {
		// Creation du Socket serveur http de base
		this.http = http.createServer((request, response) => {
			console.log((new Date()) + ' Received request for ' + request.url);
			response.writeHead(404);
			response.end();
		});
		
		// Serveur en ecoute. Seul le port est défini. Protocole http://.
		this.http.listen(this.port, () => {
			console.log((new Date()) + ' Server is listening on port ' + this.port);
		});
		
		// Mise en place du WebSocket (protocole ws://) à partir du socket serveur
		this.ws = new WebSocketServer({
					httpServer: this.http,
					autoAcceptConnections: false
					}
		);
		
		///////////////////////////////////////////////////
		this.ws.on('request', (request) => {
			if (!this.originIsAllowed(request.origin)) {
			  // Make sure we only accept requests from an allowed origin
			  request.reject();
			  console.log((new Date()) + ' Connection from origin ' + request.origin + ' rejected.');
			  return;
			}
			console.log("idmsg:", this.idmsg);
			this.connection = request.accept(this.idmsg, request.origin);
			console.log((new Date()) + ' Connection accepted. IP:', this.connection.remoteAddress, ' Port:', this.connection.socket._peername.port);
			
			// Pour chaque message reçu:
			this.connection.on('message', (message) => this.onMessage(message));

			this.connection.on('close', (reasonCode, description) => {
				console.log((new Date()) + ' Peer ' + this.connection.remoteAddress + ' disconnected.');
				let portC = this.connection.socket._peername.port;
				let adresseC = this.connection.remoteAddress;
				
				this.listeConnexions.forEach( (client, index) => {
					let port = client.socket._peername.port;
					let adresse = client.remoteAddress;
					if ( adresse == adresseC && port == portC ) 
						this.listeConnexions.splice(index, 1);
				});
			});
			
			this.listeConnexions.push(this.connection);
		});
	}
	
	onMessage() {} // A redéfinir dans la classe fille
	
	originIsAllowed(origin) {
	  // put logic here to detect whether the specified origin is allowed.
	  return true;
	}
};

module.exports = ws_comm;
