﻿//-------------------------
// Classe d'origine : tRs232 trouvée sur internet
// Classe sRs232 : adaptation en restant proche du c++ et pour faciliter l'utilisation en BTS SN
// ATTENTION : Les caractères 0x00, 0x01 sont interdits. Attention aussi aux XON XOFF
// SeA - 09/10/2019
//----------------------------------------------------------------------------
#ifndef	RS232_H
#define	RS232_H

//----------------------------------------------------------------------------
#include <stdio.h> // fOpen
#include <fcntl.h> // open
#include <unistd.h> // Termios
#include <termios.h> // Termios


//----------------------------------------------------------------------------
#define COM1	"/dev/ttyS0"
#define COM2	"/dev/ttyS1"

//----------------------------------------------------------------------------
#define BPS9600  0
#define BPS4800  1
#define BPS2400  2
#define BPS19200 3

//----------------------------------------------------------------------------
#define BIT8	0
#define BIT7	1
#define BIT6	2
#define BIT5	3

//----------------------------------------------------------------------------
#define STOP1	0
#define STOP2	1

//----------------------------------------------------------------------------
#define PAS_DE_PARITE  0
#define PARITE_PAIRE	  1
#define PARITE_IMPAIRE 2
//----------------------------------------------------------------------------
#define AVEC_FINAL	0
#define SANS_FINAL	1

//----------------------------------------------------------------------------
#define	AVEC_TIME_OUT	true
#define	SANS_TIME_OUT	false

//----------------------------------------------------------------------------
#include <iostream>
using namespace std;

class sRs232
	{
	private:
		termios Config;
		string port, message;
		
	protected:
		int fd;	//Descripteur de fichier
   //------------------------------
	public:
		// Constructeur, port série par defaut : COM1
		sRs232(void);
		// Constructeur, port série spécifique
		sRs232(string Port);
		
		//sRs232(char* pPort,int Vitesse,int NbBits,int Parite,int NbStop);
		~sRs232();
		// Configuration des paramètres de transmission. Ex : (BPS9600, BIT8, PAS_DE_PARITE)
		bool Configurer(int Vitesse,int NbBits,int Parite);
		
		// Récupérer un message d'erreur en cas de return false
		string getError();
		
		// Envoyer une chaine de caractere
		int Envoyer(string pChaine);
		
		// Recevoir Nb caracteres
		string Recevoir(int Nb);
		
		// Recevoir une chaine se terminant par un caractère spécifique
		// Le mode indique si on garde le caractère de fin dans la chaine de retour (AVEC_FINAL)
		string Recevoir(char Fin, int Mode);
		
		// Recevoir une chaine de caracteres se terminant par un caractère spécifique, avec timeout en ms
		// Le mode indique si on garde le caractère de fin dans la chaine de retour (AVEC_FINAL)
		string Recevoir(char Fin, int Mode, int Attente);
	
		// Recevoir une chaine de caracteres, avec timeout en ms
		string RecevoirCaracteres(int Attente);
		
		// Recevoir un fichier - Fin quand timeout
		bool RecevoirFichier(string NomFichier, int Attente);
   } ;

#endif
