#!/usr/bin/env node
const SerialPort = require('serialport');
const Readline = require('@serialport/parser-readline');

class dialogueTTY extends SerialPort {
	constructor (port, baud){
		var p = super(port, {baudRate: baud});
		this.port = p;
	}
	
	// Réception permanente
	modeFlow() { // Utilisation d'un PIPE et d'un PARSER
		var parser = this.port.pipe(new Readline({ delimiter: '\n' }));
		// Cela remplace le "port.on" puisqu'on passe par le parser
		// On utilise une fonction "arrow" pour conserver le contexte
		parser.on('data', (e) => this.onFlow(e));
	}
	
	// A compléter: comment traiter le flow ?
	// ou redéfinir la méthode dans une classe fille.
	onFlow(ligne) {
		console.log(ligne);
	}

	envoyer(msg) {
		this.port.write(msg);
	}

	
};

module.exports = dialogueTTY;

