<?php
require_once ('rs232.php');

/**
 * @author serge
 * @version 1.0
 * @created 02-oct.-2021 17:24:52
 * Objectif : Obtenir une trame NMEA sur la liaison srie
 * Une trame NMEA commence par $
 */
 
class gpsOnSerial
{

	
	private $trameNmea;//La chaine de caractres reus
	private $m_rs232; // l'accs au port srie

	/**
	 * port : le nom du /dev/tty
	 * 
	 * @param port
	 */
	function __construct($port)
	{
		$this->trameNmea = '$VIDE';
		$this->m_rs232 = new rs232();
		$this->m_rs232->configurer($port, 4800, "-echo -opost crtscts -hupcl");
	}

	function __destruct()
	{
	}


	/**
	 * Renvoie la dernire trame recue
	 */
	public function getTrameNmea()
	{
		$ligne = $this->m_rs232->recevoir("\n");
		
		while (  ! $this->isNmea($ligne) )
			$ligne = $this->m_rs232->recevoir("\n");
		
		$this->trameNmea = $ligne;
		return $this->trameNmea;	
	}

	/**
	 * Renvoie "vrai" si la ligne reue est une trame nmea ($ ...)
	 */
	public function isNmea($ligne)
	{
		if ( $ligne[0] == "$")
			return true;
		else
			return false;
	}

}
?>