<?php 
// Objectif : Lire les différentes partie d'une trame NMEA
//            Extraire le type de trame (1er champ)

class nmea {
	public function __construct() {
		$this->zones[0] = "";
	}
	
	// La trame reçue ($trame) sera intégrée au tableau "zones"
	// Grace à "explode", le tableau la trame découpée en fonction de la virgule
	public function updateTrame($trame) {
		$this->zones = explode(",", $trame);
	}
	
	// Retourne le type de trame ($GPGGA, $GPAAM ...)
	public function getTypeTrame() {
		return $this->zones[0];
	}
	
	// Retourne la zone de la trame indiquée par $num
	public function getZone($num) {
		if ( $num < count($this->zones))
			return $this->zones[$num];
		else
			return false;
	}
	
	// Retourne la trame complète au format Json
	public function getJson() {
		return json_encode($this->zones);
	}
}
?>